{ *************************************************************************** }
{                                                                             }
{ WindowsXP-like picture viewer                                               }
{                                                                             }
{ Copyright (c) 2003,2004 Sergey Mishin <mishinmail@mail.ru>                  }
{                                                                             }
{ This program is free software; you can redistribute it and/or               }
{ modify it under the terms of the GNU General Public                         }
{ License as published by the Free Software Foundation; either                }
{ version 2 of the License, or (at your option) any later version.            }
{                                                                             }
{ Code of procedure Rotate based on JvImageRotate.PAS, that is the            }
{ part of Project JEDI located at http://jvcl.sourceforge.net                 }                              
{ by Michael Beck [mbeck@bigfoot.com] and Andr Snepvangers [asn@xs4all.nl]   }
{                                                                             }
{ Code of procedure Rotate based on original code                             }
{ by Sbastien Buysse [sbuysse@buypin.com].                                   }
{ Portions created by Sbastien Buysse are All Rights Reserved.               }
{                                                                             }
{ This program is distributed in the hope that it will be useful,             }
{ but WITHOUT ANY WARRANTY; without even the implied warranty of              }
{ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU           }
{ General Public License for more details.                                    }
{                                                                             }
{ You should have received a copy of the GNU General Public License           }
{ along with this program; see the file COPYING.  If not, write to            }
{ the Free Software Foundation, Inc., 59 Temple Place - Suite 330,            }
{ Boston, MA 02111-1307, USA.                                                 }
{                                                                             }
{ *************************************************************************** }


unit uPicview;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QComCtrls, QExtCtrls, QImgList,uXPAPI, QButtons, Qt,
  QActnList, uRegistry, StrUtils, QMenus, GraphicEx;

type
  TfrmMain = class(TForm)
    ImageList1: TImageList;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ScrollBox1: TScrollBox;
    Panel1: TPanel;
    ToolBar1: TToolBar;
    tbSave: TToolButton;
    tbSlideShow: TToolButton;
    ToolButton3: TToolButton;
    tbBack: TToolButton;
    tbForward: TToolButton;
    ToolButton6: TToolButton;
    tbActualSize: TToolButton;
    tbResizedSize: TToolButton;
    ToolButton9: TToolButton;
    tbRotateClockwise: TToolButton;
    tbRotateCounterclockwise: TToolButton;
    tbDelete: TToolButton;
    tbPrint: TToolButton;
    ToolButton16: TToolButton;
    tbEdit: TToolButton;
    ToolButton18: TToolButton;
    tbHelp: TToolButton;
    Image: TImage;
    imgPlus: TImage;
    imgMinus: TImage;
    imgHand: TImage;
    ActionList1: TActionList;
    actHelp: TAction;
    actBack: TAction;
    actActualSize: TAction;
    actResizedSize: TAction;
    actSlideShow: TAction;
    actRotateCounterclockwise: TAction;
    actRotateClockwise: TAction;
    actDelete: TAction;
    actPrint: TAction;
    actSave: TAction;
    actEdit: TAction;
    actZoomIn: TAction;
    actZoomOut: TAction;
    actForward: TAction;
    ImageBorder: TShape;
    lblLoading: TLabel;
    PopupMenu1: TPopupMenu;
    mnuEditimage: TMenuItem;
    mnuPrint: TMenuItem;
    N1: TMenuItem;
    mnuRotateClockwise: TMenuItem;
    mnuRotateCounterclockwise: TMenuItem;
    mnuZoomIn: TMenuItem;
    mnuZoomOut: TMenuItem;
    sbZoomIn: TSpeedButton;
    sbZoomOut: TSpeedButton;
    Animate1: TAnimate;
    sbSelect: TSpeedButton;
    actSelect: TAction;
    ToolButton1: TToolButton;
    tbCurve: TToolButton;
    tbPen: TToolButton;
    tbLine: TToolButton;
    tbRect: TToolButton;
    tbGradRect: TToolButton;
    tbText: TToolButton;
    tbNote: TToolButton;
    tbUpdate: TToolButton;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ScrollBox1MouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ScrollBox1MouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure ImageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ImageMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ScrollBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ScrollBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure actHelpExecute(Sender: TObject);
    procedure actBackExecute(Sender: TObject);
    procedure actActualSizeExecute(Sender: TObject);
    procedure actResizedSizeExecute(Sender: TObject);
    procedure actSlideShowExecute(Sender: TObject);
    procedure actRotateCounterclockwiseExecute(Sender: TObject);
    procedure actRotateClockwiseExecute(Sender: TObject);
    procedure actDeleteExecute(Sender: TObject);
    procedure actPrintExecute(Sender: TObject);
    procedure actSaveExecute(Sender: TObject);
    procedure actEditExecute(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure actZoomInExecute(Sender: TObject);
    procedure actZoomOutExecute(Sender: TObject);
    procedure actForwardExecute(Sender: TObject);
    procedure SaveSettings();
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure sbZoomInMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure sbZoomOutMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure LoadImage(ImageName: String);
    procedure LoadGraphExt;
    procedure actSelectExecute(Sender: TObject);
    procedure SmoothResize(Src, Dst: TBitmap);
    procedure SmoothPicture;
    procedure FormShow(Sender: TObject);

  private
    { Private declarations }

  public
    { Public declarations }
      list: TStringList;
      Counter: integer;
  end;

var
  frmMain: TfrmMain;
  dProportion: double;
  FOriginal: TBitmap;
  FSmooth: TBitmap;
  FTemp: TBitmap;
  FColor: TColor;
  direct:string;
  sr: TSearchRec;
  exts: TStringList;
  IsGIF: boolean;

const
  MaxPixelCount = 32768;
  TopBorder=40;
  LeftBorder=40;
  IncStep=50;                        // Increment/Decrement Step Value
  crPlus=102;
  crMinus=103;
  crHand=104;



Type
  TRGBquad = packed record
    rgbtBlue: Byte;
    rgbtGreen: Byte;
    rgbtRed: Byte;
    rgbtReserved: Byte;
  end;
Type
  TRGBTriple = TRGBquad ;
  TRGBArray = array[0..MaxPixelCount - 1] of TRGBTriple;
  PRGBArray = ^TRGBArray;


implementation

uses uSlideshow;

{$R *.xfm}
resourcestring
  FormCaption='Picture and Fax Viewer';
  sMsg1='Delete file?';
  sMsg2='Loading...';


procedure TfrmMain.SmoothResize(Src, Dst: TBitmap);
var
  x, y: Integer;
  xP, yP: Integer;
  xP2, yP2: Integer;
  SrcLine1, SrcLine2: pRGBArray;
  t3: Integer;
  z, z2, iz2: Integer;
  DstLine: pRGBArray;
  DstGap: Integer;
  w1, w2, w3, w4: Integer; 
begin
  Src.PixelFormat := pf32Bit;
  Dst.PixelFormat := pf32Bit;

  if (Src.Width = Dst.Width) and (Src.Height = Dst.Height) then
    Dst.Assign(Src)
  else
  begin
    DstLine := Dst.ScanLine[0];
    DstGap  := Integer(Dst.ScanLine[1]) - Integer(DstLine);

    xP2 := MulDiv(pred(Src.Width), $10000, Dst.Width);
    yP2 := MulDiv(pred(Src.Height), $10000, Dst.Height);
    yP  := 0;

    for y := 0 to pred(Dst.Height) do
    begin 
      xP := 0; 

      SrcLine1 := Src.ScanLine[yP shr 16];

      if (yP shr 16 < pred(Src.Height)) then 
        SrcLine2 := Src.ScanLine[succ(yP shr 16)] 
      else
        SrcLine2 := Src.ScanLine[yP shr 16]; 

      z2  := succ(yP and $FFFF); 
      iz2 := succ((not yp) and $FFFF);
      for x := 0 to pred(Dst.Width) do 
      begin 
        t3 := xP shr 16; 
        z  := xP and $FFFF; 
        w2 := MulDiv(z, iz2, $10000);
        w1 := iz2 - w2; 
        w4 := MulDiv(z, z2, $10000); 
        w3 := z2 - w4; 
        DstLine[x].rgbtRed := (SrcLine1[t3].rgbtRed * w1 + 
          SrcLine1[t3 + 1].rgbtRed * w2 +
          SrcLine2[t3].rgbtRed * w3 + SrcLine2[t3 + 1].rgbtRed * w4) shr 16; 
        DstLine[x].rgbtGreen := 
          (SrcLine1[t3].rgbtGreen * w1 + SrcLine1[t3 + 1].rgbtGreen * w2 +

          SrcLine2[t3].rgbtGreen * w3 + SrcLine2[t3 + 1].rgbtGreen * w4) shr 16;
        DstLine[x].rgbtBlue := (SrcLine1[t3].rgbtBlue * w1 + 
          SrcLine1[t3 + 1].rgbtBlue * w2 + 
          SrcLine2[t3].rgbtBlue * w3 + 
          SrcLine2[t3 + 1].rgbtBlue * w4) shr 16; 
        Inc(xP, xP2);
      end;
      Inc(yP, yP2); 
      DstLine := pRGBArray(Integer(DstLine) + DstGap); 
    end;
  end;
end; 


procedure  TfrmMain.SmoothPicture;
begin
  FSmooth.Width := Image.Width;
  FSmooth.Height := Image.Height;
  //FTemp.Assign(frmMain.Image.Picture.Bitmap);
  SmoothResize(FTemp, FSmooth);
  frmMain.Image.Picture.Assign(FSmooth);
end;

procedure DrawShape;
begin
//Draw image shape
    with frmMain.ImageBorder do begin
        Left:=frmMain.Image.Left-1;
        Top:=frmMain.Image.Top-1;
        Height:=frmMain.Image.Height+2;
        Width:=frmMain.Image.Width+2;
        Visible:=True;
    end;
end;

procedure TfrmMain.SaveSettings();
    var reg: TRegistry;
begin
    reg := TRegistry.Create;

    try
        if reg.OpenKey('Software/XPde/picview', true) then begin
            reg.Writeinteger('Top', frmMain.Top);
            reg.Writeinteger('Left', frmMain.Left);
            reg.Writeinteger('Width', frmMain.Width);
            reg.Writeinteger('Height', frmMain.Height);
        end;
    finally
        reg.Free();
    end;
end;

procedure TfrmMain.LoadGraphExt;
var i: integer;
    j: Integer;
    C: Integer;
    P: PFileFormat;
begin
        exts:=TStringList.create;
        //this must working, but ...
        {C := 0;
        for i := GetFileFormats.Count-1 downto 0 do begin
          P := PFileFormat(GetFileFormats.Items[i]);
          if (P^.GraphicClass.InheritsFrom(TGraphic) or
            P^.GraphicClass.Assigns(TGraphic)) and (P^.Extension <> '') then
            with P^ do begin
                 if (Description = '') and (DescResID <> 0) then Inc(C);
                 exts.Add('*.'+Extension);
                 for j :=0  to Length(Extension) do Extension[j] := UpCase(Extension[j]);
                 exts.Add('*.'+Extension);
             end;
         end;}
        // so temporary ugly code
        exts.add('*.psp');
        exts.add('*.PSP');
        exts.add('*.cut');
        exts.add('*.CUT');
        exts.add('*.gif');
        exts.add('*.GIF');
        exts.add('*.pcd');
        exts.add('*.PCD');
        exts.add('*.pic');
        exts.add('*.PIC');
        exts.add('*.cel');
        exts.add('*.CEL');
        exts.add('*.pbm');
        exts.add('*.PBM');
        exts.add('*.pgm');
        exts.add('*.PGM');
        exts.add('*.ppm');
        exts.add('*.PPM');
        exts.add('*.pdd');
        exts.add('*.PDD');
        exts.add('*.psd');
        exts.add('*.PSD');
        exts.add('*.bw');
        exts.add('*.BW');
        exts.add('*.rgb');
        exts.add('*.RGB');
        exts.add('*.rgba');
        exts.add('*.RGBA');
        exts.add('*.sgi');
        exts.add('*.SGI');
        exts.add('*.rla');
        exts.add('*.RLA');
        exts.add('*.rpf');
        exts.add('*.RPF');
        exts.add('*.scr');
        exts.add('*.SCR');
        exts.add('*.pcc');
        exts.add('*.PCC');
        exts.add('*.pcx');
        exts.add('*.PCX');
        exts.add('*.fax');
        exts.add('*.FAX');
        exts.add('*.tif');
        exts.add('*.TIF');
        exts.add('*.tiff');
        exts.add('*.TIFF');
        exts.add('*.icb');
        exts.add('*.ICB');
        exts.add('*.tga');
        exts.add('*.TGA');
        exts.add('*.vda');
        exts.add('*.VDA');
        exts.add('*.vst');
        exts.add('*.VST');
        exts.add('*.win');
        exts.add('*.WIN');
        exts.add('*.dib');
        exts.add('*.DIB');
        exts.add('*.rle');
        exts.add('*.RLE');
        exts.add('*.ico');
        exts.add('*.ICO');
        exts.add('*.bmp');
        exts.add('*.BMP');
        exts.add('*.jpg');
        exts.add('*.JPG');
        exts.add('*.ddw');
        exts.add('*.DDW');
        exts.add('*.bmp');
        exts.add('*.BMP');
        exts.add('*.png');
        exts.add('*.PNG');
        exts.add('*.xpm');
        exts.add('*.XPM');
        exts.add('*.ico');
        exts.add('*.ICO');
        exts.add('*.jpeg');
        exts.add('*.JPEG');
        exts.add('*.ani');
        exts.add('*.ANI');

end;




procedure FillFileList;
var i: integer;

begin
     try
        if findfirst(paramstr(1),faAnyFile,sr)=0 then frmMain.list.Add(paramstr(1));
        findclose(sr);

        if direct[length(direct)]<>'/' then direct:=direct+'/';
        for i:=0 to exts.count-1 do begin
          if findfirst(direct+exts[i],faAnyFile,sr)=0 then begin
            repeat
                   if sr.PathOnly+sr.name <> paramstr(1) then
                   frmMain.list.Add(sr.PathOnly+sr.name);
            until FindNext(sr) <> 0;
           end;
          findclose(sr);
        end;
    finally
    end;

end;


procedure ImageZoom(Param:String);
var newHeight: integer;
    newWidth : integer;
begin

    frmMain.Image.AutoSize:=False;
    frmMain.Image.Stretch:=True;
    if Param= '+' then begin
         with frmMain.Image do begin
            Cursor:=crPlus;
            Height:=Height+Trunc(IncStep*dProportion);
            Width:=Width+Trunc(IncStep*dProportion);
            Left:=frmMain.Width div 2-Width div 2;
            Top:=(frmMain.Height-frmMain.ToolBar1.Height) div 2-Height div 2;
        end;
    end
    else if Param= '-' then begin
         with frmMain.Image do begin
             Cursor:=crMinus;
             newHeight:=Height-Trunc(IncStep*dProportion);
             newWidth:=Width-Trunc(IncStep*dProportion);
             if newHeight> 0 then begin
                Height:=newHeight;
                Width:=newWidth;
             end;
             Left:=frmMain.Width div 2-Width div 2;
             Top:=(frmMain.Height-frmMain.ToolBar1.Height) div 2-Height div 2;
       end;
    end;

   try
      frmMain.SmoothPicture;
   except
   end;
   
    frmMain.tbActualSize.ImageIndex:=3;
    frmMain.tbResizedSize.ImageIndex:=4;
    with frmMain.Animate1 do
    begin
        Cursor:=frmMain.Image.Cursor;
        AutoSize:=frmMain.Image.AutoSize;
        Stretch:=frmMain.Image.Stretch;
        Left:=frmMain.Image.Left;
        Top:=frmMain.Image.Top;
        Height:=frmMain.Image.Height;
        Width:=frmMain.Image.Width;
    end;
    frmMain.ScrollBox1.HorzScrollBar.Range := frmMain.Image.Width;
    frmMain.ScrollBox1.VertScrollBar.Range := frmMain.Image.Height;
    DrawShape;

end;


procedure Rotate(Value: integer);
var
  FRotated: TBitmap;
  i: Integer;
  j: Integer;
  iRotationAxis: Integer;
  iOriginal: Integer;
  iPrime: Integer;
  iPrimeRotated: Integer;
  jRotationAxis: Integer;
  jOriginal: Integer;
  jPrime: Integer;
  jPrimeRotated: Integer;
  RowOriginal: PRGBArray;
  RowRotated : PRGBArray;
  Theta   : Double;
  sinTheta: Double;
  cosTheta: Double;
  R, G, B: Byte;
begin
  FRotated:= TBitmap.Create;
  FOriginal.Assign(frmMain.Image.Picture.Bitmap);

    FRotated.Width := FOriginal.Height;
    FRotated.Height := FOriginal.Width;

  if Value= 90 then begin
      iRotationAxis := FOriginal.Height div 2;
      jRotationAxis := FOriginal.Height div 2;
  end
  else if Value= 270 then begin
      iRotationAxis := FOriginal.Width div 2;
      jRotationAxis := FOriginal.Width div 2;
  end;

  Theta := -Value * Pi / 180;
  sinTheta := Sin(Theta);
  cosTheta := Cos(Theta);
  B := FColor mod 256;
  G := Round((FColor div 256) mod 256);
  R := Round((FColor div 256) div 256);
  for j := FRotated.Height - 1 downto 0 do begin
    RowRotated := FRotated.Scanline[j];
    jPrime := 2 * (j - jRotationAxis)+1;
    for i := FRotated.Width - 1 downto 0 do begin
      iPrime := 2 * (i - iRotationAxis);
      iPrimeRotated := Round(iPrime * CosTheta - jPrime * sinTheta);
      jPrimeRotated := Round(iPrime * sinTheta + jPrime * cosTheta);
      iOriginal := (iPrimeRotated - 1) div 2 + iRotationAxis;
      jOriginal := (jPrimeRotated - 1) div 2 + jRotationAxis;
      if (iOriginal >= 0) and (iOriginal <= FOriginal.Width - 1) and
        (jOriginal >= 0) and (jOriginal <= FOriginal.Height - 1) then begin
      
        RowOriginal := FOriginal.Scanline[jOriginal];
        RowRotated[i] := RowOriginal[iOriginal]
      end
      else begin
        RowRotated[i].rgbtBlue := B;
        RowRotated[i].rgbtGreen := G;
        RowRotated[i].rgbtRed := R
      end;
    end;
  end;
  FTemp.Assign(FRotated);
  frmMain.Image.Picture.Assign(FTemp);
  FRotated.Free;


end;


procedure TfrmMain.FormResize(Sender: TObject);
var Ratio : integer;
begin

   if IsGIF then begin
      Image.Visible:=False;
   end
   else begin
      Animate1.Visible:=False;
   end;

    //Image Resizing
         Image.Picture.Assign(FTemp);
         Image.AutoSize:=True;
         if (Image.Height < (frmMain.Height-TopBorder*2)) and (Image.Width < (frmMain.Width-LeftBorder*2))
         then begin
               Image.Stretch:=False;
               tbActualSize.ImageIndex:=3;
               tbResizedSize.ImageIndex:=5;
         end
         else begin
              Image.AutoSize:=False;
              Image.Stretch:=True;
                if Image.Width > Image.Height then begin
                     try
                       dProportion:=Image.Width / (frmMain.ClientWidth-LeftBorder*2); //zerodivide !!!
                     except end;
                     Image.Width:=frmMain.ClientWidth-LeftBorder*2;
                     Image.Height:=Trunc(Image.Height / dProportion);
                 end
                 else begin
                     try
                       dProportion:=Image.Height / (frmMain.ClientHeight-TopBorder*2-ToolBar1.Height); //zerodivide !!!
                     except end;
                     Image.Height:=frmMain.ClientHeight-TopBorder*2-ToolBar1.Height;
                     Image.Width:=Trunc(Image.Width / dProportion);
                 end;

              try
                 SmoothPicture;
              except end;
                 
         end;

    //Center Image
        with Image do begin
            Left:=frmMain.ClientWidth div 2-Width div 2;
            Top:=(frmMain.ClientHeight-ToolBar1.Height) div 2-Height div 2;
        end;

    //Center Caption
        with lblLoading do begin
            Left:=frmMain.ClientWidth div 2-Width div 2;
            Top:=(frmMain.ClientHeight-ToolBar1.Height) div 2-Height div 2;
        end;

    //Image Shape
        if paramstr(1)<>'' then DrawShape;

        with ScrollBox1 do begin
             HorzScrollBar.Range := Image.Width;
             VertScrollBar.Range := Image.Height;
        end;

    //Toolbuttons images
        try
          if (FOriginal.Height <> Image.Height) or (FOriginal.Width <> Image.Width) then begin
              tbActualSize.ImageIndex:=2;
              tbResizedSize.ImageIndex:=5;
          end;
        except

        end;
        Animate1.AutoSize:=Image.AutoSize;
        Animate1.Top:=Image.Top;
        Animate1.Left:=Image.Left;

end;



procedure TfrmMain.FormCreate(Sender: TObject);
var reg: TRegistry;

begin

   //  XPAPI.setdefaultcursor;
    with screen do begin
        cursors[crPlus]:=QCursor_create(imgPlus.Picture.Bitmap.handle,0,0);
        cursors[crMinus]:=QCursor_create(imgMinus.Picture.Bitmap.handle,0,0);
        cursors[crHand]:=QCursor_create(imgHand.Picture.Bitmap.handle,0,0);
    end;

    lblLoading.Caption:=sMsg2;
    reg := TRegistry.Create();
    try
        if Reg.OpenKey('Software/XPde/picview', false) then begin
            frmMain.Top := reg.Readinteger('Top');
            frmMain.Left := reg.Readinteger('Left');
            frmMain.Height := reg.Readinteger('Height');
            frmMain.Width := reg.Readinteger('Width');
        end;
    finally
        reg.Free();
    end;

   if paramstr(1)<>'' then begin
       direct:=ExtractFilePath(paramstr(1));
    end
    else begin
        direct:=ExtractFilePath(Application.ExeName);
    end;

    LoadGraphExt;

    list:=TStringList.create;
    FillFileList;

    FOriginal := TBitmap.Create;
    FSmooth:= TBitmap.Create;
    FTemp:= TBitmap.Create;

    Counter:=0;
    IsGIF:=False;

    LoadImage(paramstr(1));
    

end;

procedure TfrmMain.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    SaveSettings();
    Action:=caFree;
end;

procedure TfrmMain.ScrollBox1MouseWheelDown(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin

    ImageZoom('-');
end;

procedure TfrmMain.ScrollBox1MouseWheelUp(Sender: TObject;
  Shift: TShiftState; MousePos: TPoint; var Handled: Boolean);
begin

    ImageZoom('+');
end;

procedure TfrmMain.ImageMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if Button=mbMiddle then Image.Cursor:=crHand;
    if Button=mbLeft then begin
         if sbZoomIn.Down=True then ImageZoom('+');
         if sbZoomOut.Down=True then ImageZoom('-');;
    end;

end;

procedure TfrmMain.ImageMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if Button=mbMiddle then Image.Cursor:=crDefault;
end;

procedure TfrmMain.ScrollBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if Button=mbMiddle then ScrollBox1.Cursor:=crHand;
end;

procedure TfrmMain.ScrollBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if Button=mbMiddle then ScrollBox1.Cursor:=crDefault;
end;

procedure TfrmMain.actHelpExecute(Sender: TObject);
begin
        ShowMessage('Help!!!  Everybody help!!!  Help me !!!   ;-) ');
end;

procedure TfrmMain.actBackExecute(Sender: TObject);
begin
    lblLoading.Visible:=True;
    Image.Visible:=False;
    Dec(Counter);
    if Counter=-1 then Counter:=list.Count-1;
    LoadImage(list.Strings[Counter]);

end;

procedure TfrmMain.actActualSizeExecute(Sender: TObject);
begin

    with Image do begin
        Picture.Assign(Ftemp);
        ScrollBox1.HorzScrollBar.Range := Picture.Width;
        ScrollBox1.VertScrollBar.Range := Picture.Height;
        AutoSize:=True;
        Left:=frmMain.Width div 2-Width div 2;
        Top:=(frmMain.Height-ToolBar1.Height) div 2-Height div 2;
    end;
    tbActualSize.ImageIndex:=3;
    tbResizedSize.ImageIndex:=4;
    DrawShape;

end;

procedure TfrmMain.actResizedSizeExecute(Sender: TObject);
begin
    tbActualSize.ImageIndex:=2;
    tbResizedSize.ImageIndex:=5;
    FormResize(Self);

end;

procedure TfrmMain.actSlideShowExecute(Sender: TObject);
begin
        Application.CreateForm(TfrmSlide, frmSlide);
        if IsGIF then begin
           frmSlide.AniSlide.Filename:=list.Strings[Counter];
           frmSlide.AniSlide.Active:=True;
        end
        else frmSlide.imgSlide.Picture:=frmMain.Image.Picture ;
        frmSlide.Show;
end;

procedure TfrmMain.actRotateCounterclockwiseExecute(Sender: TObject);
begin
   Image.Stretch:=False;
   Rotate(270);
   FormResize(Self);

end;

procedure TfrmMain.actRotateClockwiseExecute(Sender: TObject);
begin
   Image.Stretch:=False;
   Rotate(90);
   IsGIF:=False;
   FormResize(Self);
end;

procedure TfrmMain.actDeleteExecute(Sender: TObject);
begin

 if MessageDlg(sMsg1,mtConfirmation,[mbYes,mbNo],0,mbYes)=mrYes then begin
    DeleteFile(list.Strings[Counter]);
    list.Clear;
    FillFileList;
    Counter:=0;
    Image.Picture.LoadFromFile(list.Strings[Counter]);
    frmMain.Caption:=ExtractFileName(list.Strings[Counter])+' - '+ FormCaption;
    FormResize(Self);
 end;

end;

procedure TfrmMain.actPrintExecute(Sender: TObject);
begin
        ShowMessage('Not implemented yet!');
end;

procedure TfrmMain.actSaveExecute(Sender: TObject);
begin
    if SaveDialog1.Execute then
       Image.Picture.Bitmap.SaveToFile(SaveDialog1.FileName);
end;

procedure TfrmMain.actEditExecute(Sender: TObject);
begin
        XPAPI.ShellExecute('/opt/xpde/bin/apps/paint '+list.Strings[Counter],false);
end;

procedure TfrmMain.FormKeyPress(Sender: TObject; var Key: Char);
begin

  if Key='+' then begin
     sbZoomIn.Down:=True;
     sbZoomOut.Down:=False;
     actZoomInExecute(Self);
  end;
  if Key='-' then begin
     sbZoomIn.Down:=False;
     sbZoomOut.Down:=True;
     actZoomOutExecute(Self);
  end;

end;

procedure TfrmMain.actZoomInExecute(Sender: TObject);
begin
    ImageZoom('+');
end;

procedure TfrmMain.actZoomOutExecute(Sender: TObject);
begin
   ImageZoom('-');
end;

procedure TfrmMain.actForwardExecute(Sender: TObject);
begin
    lblLoading.Visible:=True;
    Image.Visible:=False;

    inc(Counter);
    if Counter=list.Count then Counter:=0;
    LoadImage(list.Strings[Counter]);

end;

procedure TfrmMain.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key=4114) or (Key=4117) then actBackExecute(Self);
  if (Key=4116) or (Key=4115) then actForwardExecute(Self);
  if (Key=4101) or (Key=4100) then actResizedSizeExecute(Self);
end;

procedure TfrmMain.sbZoomInMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
        actZoomInExecute(Self);
end;

procedure TfrmMain.sbZoomOutMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
        actZoomOutExecute(Self);
end;

procedure TfrmMain.LoadImage(ImageName: String);
begin
    {if (RightStr(ImageName,3)='tif') or (RightStr(ImageName,3)='TIF') then begin
       ToolBar1.Width:=585;
       sbZoomIn.Visible:=True;
       sbZoomOut.Visible:=True;
       sbSelect.Visible:=True;
       tbRotateCounterclockwise.Visible:=True;
       tbRotateClockwise.Visible:=True;
       ToolButton6.Visible:=True;
       tbCurve.Visible:=True;
       tbPen.Visible:=True;
       tbLine.Visible:=True;
       tbRect.Visible:=True;
       tbGradRect.Visible:=True;
       tbText.Visible:=True;
       tbNote.Visible:=True;
       tbDelete.Visible:=True;
       tbPrint.Visible:=True;
       tbUpdate.Visible:=True;
       tbSave.Visible:=True;
       tbEdit.Visible:=True;
    end
    else begin
       ToolBar1.Width:=380;
       sbZoomIn.Visible:=True;
       sbZoomOut.Visible:=True;
       sbSelect.Visible:=False;
       tbRotateCounterclockwise.Visible:=True;
       tbRotateClockwise.Visible:=True;
       ToolButton6.Visible:=False;
       tbCurve.Visible:=False;
       tbPen.Visible:=False;
       tbLine.Visible:=False;
       tbRect.Visible:=False;
       tbGradRect.Visible:=False;
       tbText.Visible:=False;
       tbNote.Visible:=False;
       tbDelete.Visible:=True;
       tbPrint.Visible:=True;
       tbUpdate.Visible:=False;
       tbSave.Visible:=True;
       tbEdit.Visible:=True;
    end;}
    ToolBar1.Width:=390;
    ToolBar1.Left:=(frmMain.ClientWidth-ToolBar1.Width) div 2;

    if (RightStr(ImageName,3)='gif') or (RightStr(ImageName,3)='GIF') then begin
        IsGIF:=True;
        tbRotateClockwise.Enabled:=False;
        tbRotateCounterclockwise.Enabled:=False;
        mnuRotateClockwise.Enabled:=False;
        mnuRotateCounterclockwise.Enabled:=False;
        with Animate1 do
        begin
                Filename:=ImageName;
                Visible:=True;
                Active:=True;
        end;
            try
               FOriginal.LoadFromFile(ImageName);
               Image.Picture.Assign(FOriginal);
               FTemp:=FOriginal;
            except
            end;
            Image.Visible:=False;
    end
    else begin
        IsGIF:=False;
        tbRotateClockwise.Enabled:=True;
        tbRotateCounterclockwise.Enabled:=True;
        mnuRotateClockwise.Enabled:=True;
        mnuRotateCounterclockwise.Enabled:=True;
        with Animate1 do
        begin
            Visible:=False;
            Active:=False;
        end;
        Image.Visible:=True;
        try
           FOriginal.LoadFromFile(ImageName);
           Image.Picture.Assign(FOriginal);
           FTemp:=FOriginal;
        except
            try
               Image.Picture.LoadFromFile(ImageName);
               FTemp.Assign(Image.Picture.Graphic);
            except

            end;
        end;
   end;

   if (FOriginal.Width<>Image.Width ) or (FOriginal.Height<>Image.Height) then
   begin
        tbActualSize.ImageIndex:=2;
        tbResizedSize.ImageIndex:=5;
   end;

  FormResize(Self);
  frmMain.Caption:=ExtractFileName(ImageName)+' - '+ FormCaption;
  lblLoading.Visible:=False;

end;



procedure TfrmMain.actSelectExecute(Sender: TObject);
begin
//
end;

procedure TfrmMain.FormShow(Sender: TObject);
begin
     FormResize(Self);
end;

end.
