unit uSlideshow;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms, 
  QDialogs, QStdCtrls, QComCtrls, QExtCtrls, QImgList, QButtons, StrUtils;

type
  TfrmSlide = class(TForm)
    Panel1: TPanel;
    ToolBar1: TToolBar;
    tbForward: TToolButton;
    tbBack: TToolButton;
    ImageList1: TImageList;
    imgSlide: TImage;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    tbClose: TToolButton;
    Timer1: TTimer;
    sbStart: TSpeedButton;
    sbPause: TSpeedButton;
    AniSlide: TAnimate;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure tbCloseClick(Sender: TObject);
    procedure tbForwardClick(Sender: TObject);
    procedure tbBackClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure sbStartClick(Sender: TObject);
    procedure sbPauseClick(Sender: TObject);
    procedure LoadSlide(SlideName: String);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

const
  crDummy=105;  

var
  frmSlide: TfrmSlide;
  SlideCounter: integer;

implementation

uses uPicview;

{$R *.xfm}

procedure CenterSlide;
begin

    with frmSlide.imgSlide do
    begin
        AutoSize:=True;
        Left:=Screen.Width div 2- Width div 2;
        Top:=Screen.Height div 2- Height div 2;
    end;

    with frmSlide.AniSlide do
    begin
        AutoSize:=True;
        Left:=Screen.Width div 2- Width div 2;
        Top:=Screen.Height div 2- Height div 2;
    end;



end;

procedure TfrmSlide.FormCreate(Sender: TObject);
begin
     frmSlide.Top:=0;
     frmSlide.Left:=0;
     frmSlide.Width:=Screen.Width;
     frmSlide.Height:=Screen.Height;
        Panel1.Top:=0;
        Panel1.Left:=Screen.Width - Panel1.Width;
     SlideCounter:=frmMain.Counter;
     if IsGIF then begin
        imgSlide.Visible:=False;
        AniSlide.Visible:=True;
     end
     else begin
        imgSlide.Visible:=True;
        AniSlide.Visible:=False;
     end;                 
end;

procedure TfrmSlide.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    Action:=caFree;
end;

procedure TfrmSlide.FormShow(Sender: TObject);
begin
     CenterSlide;
end;

procedure TfrmSlide.tbCloseClick(Sender: TObject);
begin
    frmSlide.Close;
end;

procedure TfrmSlide.tbForwardClick(Sender: TObject);
begin
      inc(SlideCounter);
      if SlideCounter=frmMain.list.Count then SlideCounter:=0;
      LoadSlide(frmMain.list.Strings[SlideCounter]);
end;

procedure TfrmSlide.tbBackClick(Sender: TObject);
begin
      Dec(SlideCounter);
      if SlideCounter=-1 then SlideCounter:=frmMain.list.Count-1;
      LoadSlide(frmMain.list.Strings[SlideCounter]);
end;

procedure TfrmSlide.Timer1Timer(Sender: TObject);
begin
   Panel1.Visible:=False;
   tbForwardClick(Self);
end;

procedure TfrmSlide.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   Panel1.Visible:=True;
end;

procedure TfrmSlide.sbStartClick(Sender: TObject);
begin
    Timer1.Enabled:=True;
end;


procedure TfrmSlide.sbPauseClick(Sender: TObject);
begin
     Timer1.Enabled:=False;
end;


procedure TfrmSlide.LoadSlide(SlideName: String);
begin
      if (RightStr(SlideName,3)='gif') or (RightStr(SlideName,3)='GIF') then begin
          IsGIF:=True;
          with AniSlide do
          begin
               Filename:=SlideName;
               Active:=True;
               Visible:=True;
          end;
          imgSlide.Visible:=False;
      end
      else begin
            IsGIF:=False;
            AniSlide.Visible:=False;
            AniSlide.Active:=False;
            imgSlide.Visible:=True;
            try
               FOriginal.LoadFromFile(SlideName);
               imgSlide.Picture.Assign(FOriginal);
            except
                  try
                     imgSlide.Picture.LoadFromFile(SlideName);
                  except

                  end;
            end;
      end;
      CenterSlide;
end;




end.
